//+------------------------------------------------------------------+
//|                                                    MA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//| original idea by Jose Silva                                      |
//| Ma Channel Ribbon filled Modified by Steven                      |
//+------------------------------------------------------------------+

//------------------------------------TESTING-----------------------//
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 10
#property indicator_color1 Crimson
#property indicator_color2 Blue
#property indicator_color3 DarkBlue
#property indicator_color4 FireBrick
#property indicator_color5 DarkGreen
#property indicator_color6 Aqua
#property indicator_color7 LimeGreen//wicks
#property indicator_color8 DarkOrange//wicks
#property indicator_color9 LimeGreen // Candle Bodies
#property indicator_color10 DarkOrange // Candle Bodies
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 4
#property indicator_width4 4
#property indicator_width5 1
#property indicator_width6 3
//
//
//
//
//

extern int                 MaFastPeriod    = 5;
extern ENUM_MA_METHOD      MaFastMethod    = MODE_EMA;
extern ENUM_APPLIED_PRICE  MaFastPrice     = PRICE_CLOSE;
extern int                 ChannelPeriod   = 50;
extern ENUM_MA_METHOD      ChannelMethod   = MODE_EMA;
extern bool   AlertOn             = false;
extern bool   ShowArrows          = true;
extern int    ArrowWidth          = 1;
extern double ArrowsUpGap         = 1;
extern double ArrowsDnGap         = 1;
extern color  ArrowsUpColor       = Green;
extern color  ArrowsDnColor       = Red;

extern int    CandlePeriod        =34; // Candle MA Period
extern ENUM_MA_METHOD CandleMethod  =MODE_EMA;; // Candle MA Method
extern ENUM_APPLIED_PRICE CandlePrice =0; // Candle Price
extern int CandleShift            =0; // Candle MA Shift
extern int CandleShadowWidth      =1;
extern int CandleBodyWidth        =3;
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
int Trend=0,SignalCandle=0;
bool AlertOnClosedCandle=1;
datetime LastAlert=0;

//MA Candle
int MA1=1;
int MA1_MODE=0;
int MA1_PRICE = 0;
int MA1_SHIFT = 0;
//--- indicator buffers
double Bar1[],Bar2[],Candle1[],Candle2[];
//---
//---
double MA_1 (int i = 0){return(iMA(NULL,0,MA1,MA1_SHIFT,MA1_MODE, MA1_PRICE,i));}
double MA_2 (int i = 0){return(iMA(NULL,0,CandlePeriod,CandleShift,CandleMethod, CandlePrice,i));}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{

   SetIndexBuffer(0,buffer5);   
   SetIndexBuffer(1,buffer6);  
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);       
   SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_HISTOGRAM); 
   SetIndexBuffer(4,buffer1);
   SetIndexBuffer(5,buffer2);
   
//MaCandle
   SetIndexBuffer(0,Bar1); SetIndexStyle(0,DRAW_HISTOGRAM,0,CandleShadowWidth);
   SetIndexBuffer(1,Bar2); SetIndexStyle(1,DRAW_HISTOGRAM,0,CandleShadowWidth);
   SetIndexBuffer(2,Candle1); SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleBodyWidth);
   SetIndexBuffer(3,Candle2); SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleBodyWidth);


   if (AlertOnClosedCandle) SignalCandle=1;
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int deinit() { 
 
   Comment("");
   if (ShowArrows) {
      for (int i=ObjectsTotal()-1;i>=0;i--) {
         if (StringFind(ObjectName(i),"MAChannel")>-1) ObjectDelete(ObjectName(i));
         }
      }
   ObjectDelete("Comment");   
   ObjectDelete("Trade");
   ObjectDelete("mMyLine");
   ObjectDelete("mMyLine2");
   ObjectDelete("mMyLine3");
   return(0);
} 
//+------------------------------------------------------------------+
//| Ma Candle Calculation                                            |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   for(int i=MathMax(Bars-1-IndicatorCounted(),1); i>=0; i--)
     {
      double   Ma1 = MA_1(i);
      double   Ma2 = MA_2(i);
      //---
        {
         if(Ma1>Ma2)
           {
            SetCandleColor(1,i);
           }
         else
           {
            if(Ma1<Ma2) SetCandleColor(2,i);
           }
        }
     }
//---
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //

   for(i=limit; i>=0; i--)
   {
      buffer1[i] = iMA(NULL,0,MaFastPeriod,0,MaFastMethod,MaFastPrice,i);
      buffer2[i] = iMA(NULL,0,ChannelPeriod,0,ChannelMethod,PRICE_MEDIAN,i);
      buffer5[i] = iMA(NULL,0,ChannelPeriod,0,ChannelMethod,PRICE_HIGH,i);
      buffer6[i] = iMA(NULL,0,ChannelPeriod,0,ChannelMethod,PRICE_LOW,i);      
      buffer3[i] = buffer1[i];
      buffer4[i] = buffer2[i];

      if (buffer1[i+SignalCandle]>buffer5[i+SignalCandle] && buffer1[i+1+SignalCandle]<=buffer5[i+1+SignalCandle] && Trend<1) {
         Trend=1;
	      if (ShowArrows) DrawArrow(i+SignalCandle,buffer5[i+SignalCandle],ArrowsUpColor,ArrowsUpGap,233,false);
	      }
      else if (buffer1[i+SignalCandle]<buffer6[i+SignalCandle] && buffer1[i+1+SignalCandle]>=buffer6[i+1+SignalCandle] && Trend>-1) {
      	Trend=-1;
      	if (ShowArrows) DrawArrow(i+SignalCandle,buffer6[i+SignalCandle],ArrowsDnColor,ArrowsDnGap,234,true);
         }
   }
   if (buffer1[SignalCandle]>buffer5[SignalCandle] && buffer1[SignalCandle+1]<=buffer5[SignalCandle+1] && LastAlert!=Time[0]) {
      LastAlert=Time[0];
      if (AlertOn) Alert("MA Channel Buy Alert! - "+Symbol()+"["+Period()+"m]");
      }
   else if (buffer1[SignalCandle]<buffer6[SignalCandle] && buffer1[SignalCandle+1]>=buffer6[SignalCandle+1] && LastAlert!=Time[0]) {
      LastAlert=Time[0];
      if (AlertOn) Alert("MA Channel Sell Alert! - "+Symbol()+"["+Period()+"m]");
      }   
   return(0);
}
void DrawArrow(int i, double ma, color theColor, double tgap, int theCode,bool up) {
   string name = "MAChannel:"+Time[i];
   double gap  = tgap*iATR(NULL,0,10,i);   
   ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      ObjectSet(name,OBJPROP_ARROWCODE,theCode);
      ObjectSet(name,OBJPROP_COLOR,theColor);
      ObjectSet(name,OBJPROP_WIDTH,ArrowWidth);
      if (up)
            ObjectSet(name,OBJPROP_PRICE1,ma+gap);
      else  ObjectSet(name,OBJPROP_PRICE1,ma-gap);
   return;
}
//+------------------------------------------------------------------+
//|MA Candle                                                                  |
//+------------------------------------------------------------------+
void SetCandleColor(int col,int i)
  {
   double high,low,bodyHigh,bodyLow;
//---
   bodyHigh= MathMax(Open[i],Close[i]);
   bodyLow = MathMin(Open[i],Close[i]);
   high= High[i];
   low = Low[i];
//---
   Bar1[i]    = EMPTY_VALUE;
   Bar2[i]    = EMPTY_VALUE;
   Candle1[i] = EMPTY_VALUE;
   Candle2[i] = EMPTY_VALUE;
//---
   switch(col)
     {
      case 1: Bar1[i] = high; Bar2[i] = low; Candle1[i] = bodyHigh; Candle2[i] = bodyLow; break;
      case 2: Bar2[i] = high; Bar1[i] = low; Candle2[i] = bodyHigh; Candle1[i] = bodyLow; break;
     }
  }
//---
double workTma[][1];